#ifndef _ZNODEMGR_H_
#define _ZNODEMGR_H_
#include "define.h"
#include "ZCParsedData.h"
#include "zdefine.h"
#include "ZMesh.h"
#include "ZBone.h"
#include "ZSkinnedMesh.h"
#include "ZRigidMesh.h"

/**
 *  ϱ Ŭ
 *
 */
class ZNodeMgr
{
protected:
	ZObjectInfo				m_info;			///  ü  
	vector<ZMaterial>		m_materials;	///  迭
	vector<ZNode*>			m_nodes;		/// 
	LPDIRECT3DDEVICE9		m_pDev;			/// D3D̽
	D3DXMATRIXA16			m_matTM;		/// ڽ  ü  TM

public:
	ZNodeMgr( LPDIRECT3DDEVICE9 pDev, ZCParsedData* pData );
	~ZNodeMgr();

	/// TM ´
	D3DXMATRIXA16*	GetTM() { &m_matTM; }

	/// TM Ѵ
	void SetTM( D3DXMATRIXA16* pTM ) { m_matTM = *pTM; }

	/// ִϸ̼  
	int Animate( float fFrame );

	/// ü ׸.
	int Draw();
};

#endif // _ZNODEMGR_H_