float MAP_CX;
float MAP_CY;

sampler Sampler;

float4 main( float2 Tex  : TEXCOORD0) : COLOR
{
	float BlurWeight[7] = { 0.1, 0.358, 0.773, 1.0, 0.773, 0.358, 0.1 };
	float BlurN = 3;
	float4 Color = 0;
	
	Color += BlurWeight[0] * ( tex2D( Sampler, Tex + float2( -3.0 / MAP_CX, 0 ) ) );
	Color += BlurWeight[1] * ( tex2D( Sampler, Tex + float2( -2.0 / MAP_CX, 0 ) ) );
	Color += BlurWeight[2] * ( tex2D( Sampler, Tex + float2( -1.0 / MAP_CX, 0 ) ) );
	Color += BlurWeight[3] * ( tex2D( Sampler, Tex + float2(  0.0 / MAP_CX, 0 ) ) );
	Color += BlurWeight[4] * ( tex2D( Sampler, Tex + float2( +1.0 / MAP_CX, 0 ) ) );
	Color += BlurWeight[5] * ( tex2D( Sampler, Tex + float2( +2.0 / MAP_CX, 0 ) ) );
	Color += BlurWeight[6] * ( tex2D( Sampler, Tex + float2( +3.0 / MAP_CX, 0 ) ) );

	return Color/BlurN;
}
