// ؽó μ ũ
float MAP_CX;
float MAP_CY;

sampler Sampler;

float4 main( float2 Tex : TEXCOORD0 ) : COLOR
{
	float mask[9] = 
		{ 0.0, 0.1, 0.0, 
		  0.1, 1.0, 0.1, 
		  0.1, 0.1, 0.0 }; // Laplacian
       
	float coord[3] = { -1, 0, +1 };
    
	float4 Color = 0;

    for( int i = 0 ; i < 9 ; i++ )
        Color += mask[i] * ( tex2D( Sampler, Tex + float2( coord[i%3]/MAP_CX, coord[i/3]/MAP_CY ) ) );

    return Color;
}
