// ȯ
float4x4 World      : WORLD;
float4x4 View       : VIEW;
float4x4 Projection : PROJECTION;

float3 VP;		// view position
float4 MTRL_D;	// diffuse material
float4 MTRL_S;	// specular material
float3 LIGHT;	// light pos
float  ratio;	// 

#define SPECULAR_POW	8

struct VS_OUT
{
	float4 Pos    : POSITION;
	float4 D	  : COLOR0;		// diffuse color
	float4 S	  : COLOR1;		// specular color
	float2 Tex    : TEXCOORD0;	// texture coord
	float3 R      : TEXCOORD1;	// reflection vector
};

VS_OUT main(
	float3 inPos  : POSITION,
	float3 inNorm : NORMAL,
	float2 inTex  : TEXCOORD0 )
{
	float4 I_A = { 0.1f, 0.1f, 0.1f, 1.0f };    // ambient intensity
	
	VS_OUT	o;
	
	// view
	float4x4 WV = mul( World, View );
	float3 P = mul(float4(inPos, 1), (float4x3)WV);
	o.Pos = mul(float4(P, 1), Projection);

    //  (view space)
    float3 L = mul( float4( LIGHT, 1 ), (float4x3)View );
    L = L - P;
    
	//  view
    float3 N = normalize(mul( inNorm, (float3x3)WV));

	// ݻ纤͸ Ѵ(view )
    float3 R = normalize(2 * dot(N, L) * N - L);

	// view͸ Ѵ(view )
    float3 V = -normalize(P);
	
 	// ֺ(ambient) + Ȯ걤(diffuse)
	o.D = I_A + MTRL_D * max(0, dot( N, L));

    // ݻ籤(specular)
    o.S = MTRL_S * pow(max(0, dot(R, V)), SPECULAR_POW);
    
	// ؽó
	o.Tex = normalize( float2( inPos.x, inPos.y ) );

	// ǥ迡  ġ
	P = mul( float4(inPos,1), World ).xyz;

	// ǥ迡  
	N = mul( inNorm, (float3x3)World );
	N = normalize( N );

	// ( - ī޶) Ի纤(entering vector) Ѵ
	float3 I = VP - P;
	
	//   Ի纤 ͸ Ѵ.
	o.R = ratio * dot(I, N) * N-I;

	return o;
}